
/* 
 * File: Pic16F1527_hardware.h   
 * Author: Alexander Zeller
 * Comments: 
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> //include processor files - each processor file is guarded.  
#include <stdint.h>

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

// TODO If C++ is being used, regular C code needs function names to have C 
// linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

// Definitions
#define _XTAL_FREQ  16000000  // this is used by the __delay_ms(xx) 
                                //and __delay_us(xx) functions
//Pins for PMW
#define PWM4 RE2
#define PWM3 RE3
#define PWM2 RE4
#define PWM1 RE5
// Names for functions
#define AN18 18
#define AN19 19
#define AN20 20
#define AN21 21
#define AN22 22
#define SW0 0
#define SW1 1
#define SW2 2
#define SW3 3
#define SW4 4
#define SW5 5 
#define SW6 6
#define SW7 7
#define SW8 8 
#define SW9 9
#define SW10 10

#define HIGH 1
#define LOW 0

#define HIGH_STABIL 11
#define HIGH_INSTABIL 12
#define LOW_STABIL 13
#define LOW_INSTABIL 14

// Functions

/* Inits */
void WDT_Config();
void OscConfig();
void PinConfig();
void initPWM();

void initADC_AN18();
void initADC_AN19();
void initADC_AN20();
void initADC_AN21();
void initADC_AN22();

/* Operations */
void ADCtoPWM();
void SwitchToPWM();
unsigned int read_ADC18 ();
unsigned int read_ADC19 ();
unsigned int read_ADC20 ();
unsigned int read_ADC21 ();
unsigned int read_ADC22 ();
int digitalRead(int port);
int isPressed(int taster); 
void SwitchOrPWM();


/* Zykluszet */
unsigned int getSystemTimeMillis(void);
void setSystemTimer(void);
void t1Int(void);

void Hardware_getChannelValues(uint8_t *channelValues);
void Hardware_setChannelValues(uint8_t *channelValues);
void Hardware_UpdatePWM();

//void ADCtoPWM_einzel();
//void SwitchToPWM_einzel(); 
/* Delays */
// void mydelay_ms(unsigned int cycles);
// void mydelay_sec(unsigned int cycles);

